#ifndef CRTOOLS
#define CRTOOLS
#include <windows.h>
#include <assert.h>
#include <stdlib.h>
#include <cstdio>


bool injectDll (DWORD pid, char *lpszDllName);
FARPROC* findFP(FARPROC proc, char* dllname, char* moduleName);
DWORD getPID(char* name);
void msg(const char*);



template <typename TFunc> class TIntrFunc {
private:
	char dllName[256];
	char funcName[256];
	char moduleName[255];
	TFunc forig;
	TFunc fsubs;
	TFunc* fp;
	bool fic;
public:
	TIntrFunc (const char* adllName, const char* afuncName, const char* amoduleName, TFunc as);
	TIntrFunc (TFunc* afp, TFunc as);
	bool ic(void) { return fic;};
	TFunc orig() {return forig;};
	TFunc subs() {return fsubs;};
	TFunc deuf() {return *fp;};
	void enable(); 
	void disable();
};

template <typename TFunc> 
TIntrFunc<TFunc>::TIntrFunc(const char* adllName, const char* afuncName, const char* amoduleName, TFunc as) {
	strcpy(dllName, adllName);
	strcpy(funcName, afuncName);
	strcpy(moduleName, amoduleName);
	forig = (TFunc)GetProcAddress(GetModuleHandle(dllName), funcName);
	fic=false;
	

	fp = (TFunc*)findFP((FARPROC)forig, dllName, moduleName);
	msg("fp");
	fsubs = as;
	if (*fp != forig) abort();
}

template <typename TFunc> 
TIntrFunc<TFunc>::TIntrFunc(TFunc* afp, TFunc as) {
	fp = afp; 
	fic = false;
	forig = *fp; 
	fsubs = as;
}

template <typename TFunc> 
void TIntrFunc<TFunc>::enable() {
	//if (fic) return;
	char str[255];
	DWORD op;
	DWORD op1;
	DWORD w;
	assert( VirtualProtect(fp,4,PAGE_READWRITE, &op) );
	
	WriteProcessMemory(GetCurrentProcess(), (void*)fp,
                      &fsubs, 4,&w);
	VirtualProtect(fp,4,op, &op1);
	
		
	if (*fp != fsubs){
		sprintf (str, "Error: fp = %x, *fp = %x", fp, *fp);
		msg(str);
	}

	fic = true; 
	return;
};

template <typename TFunc> 
void TIntrFunc<TFunc>::disable() {
	if (!fic) return;
	DWORD op;
	DWORD w;
	assert (sizeof(void*) == sizeof(FARPROC*));
	VirtualProtect(fp,4,PAGE_READWRITE, &op);
	WriteProcessMemory(GetCurrentProcess(), (void*)fp,
                      &forig, 4,&w);
	VirtualProtect(fp,4,op, &op);
	assert (w == 4);
	fic = false; 
};


#endif