// foreign.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include <Windows.h>
#include <Wingdi.h>
#include <fstream>
#include <iostream>
#include <mmsystem.h>
#include <deque>
#include <iterator>
#include "../../arch/crtools.h"
#include "../common.h"

typedef struct {
	unsigned char start; 
	unsigned char end; 
	DWORD unicode;
} Tloem1;
const int nloem1 = 2; 
Tloem1 loem1[nloem1] = {
	{0x00, 0x7e, 0x0000},
	{0x80, 0xaf, 0x0410}
};
typedef struct {
	unsigned char ch; 
	wchar_t wcs[4];
} Tloem2;
	
const int nloem2 = 79; 
Tloem2 loem2[nloem2] =  {
	{ 0x7f, {0x007e, 0x0000, 0x0000} }, // |
	{ 0xb0, {0x0069, 0x003a, 0x0000} }, //i:
	{ 0xb1, {0x0251, 0x003a, 0x0000} }, //a:
	{ 0xb2, {0x0254, 0x003a, 0x0000} }, //open o :
	{ 0xb3, {0x0075, 0x003a, 0x0000} }, //u:
	{ 0xb4, {0x0259, 0x003a, 0x0000} }, //schwa:
	{ 0xb5, {0x028c, 0x0000, 0x0000} }, //turned V
	{ 0xb6, {0x0259, 0x0000, 0x0000} }, //schwa
	{ 0xb7, {0x00e6, 0x0000, 0x0000} }, //latin small ligature ae
	{ 0xb8, {0x0254, 0x0000, 0x0000} }, //open o
	{ 0xb9, {0x00f0, 0x0000, 0x0000} }, //eth
	{ 0xba, {0x0292, 0x0000, 0x0000} }, //ezh
	{ 0xbb, {0x02a4, 0x0000, 0x0000} }, //dezh
	{ 0xbc, {0x014b, 0x0000, 0x0000} }, //eng
	{ 0xbd, {0x0075, 0x0000, 0x0000} }, //u
	{ 0xbe, {0x019f, 0x0000, 0x0000} }, //bared o (3b8, 275) 
	{ 0xbf, {0x0283, 0x0000, 0x0000} }, //esh
	{ 0xc0, {0x02a7, 0x0000, 0x0000} }, //tesh
	{ 0xc1, {0x0131, 0x0000, 0x0000} }, //i dotless
	{ 0xc2, {0x0065, 0x0000, 0x0000} }, //e
	{ 0xc3, {0x0070, 0x0000, 0x0000} }, //p
	{ 0xc4, {0x0062, 0x0000, 0x0000} }, //b
	{ 0xc5, {0x006d, 0x0000, 0x0000} }, //m
	{ 0xc6, {0x0077, 0x0000, 0x0000} }, //w
	{ 0xc7, {0x0066, 0x0000, 0x0000} }, //f
	{ 0xc8, {0x0076, 0x0000, 0x0000} }, //v
	{ 0xc9, {0x0073, 0x0000, 0x0000} }, //s
	{ 0xca, {0x007a, 0x0000, 0x0000} }, //z
	{ 0xcb, {0x0074, 0x0000, 0x0000} }, //t
	{ 0xcc, {0x0064, 0x0000, 0x0000} }, //d
	{ 0xcd, {0x006e, 0x0000, 0x0000} }, //n
	{ 0xce, {0x006c, 0x0000, 0x0000} }, //l
	{ 0xcf, {0x0072, 0x0000, 0x0000} }, //r
	{ 0xd0, {0x006b, 0x0000, 0x0000} }, //k
	{ 0xd1, {0x0067, 0x0000, 0x0000} }, //g
	{ 0xd2, {0x0068, 0x0000, 0x0000} }, //h
	{ 0xd3, {0x0061, 0x0000, 0x0000} }, //j
	{ 0xd4, {0x025b, 0x0000, 0x0000} }, //open e
	{ 0xd5, {0x0061, 0x0000, 0x0000} }, //a
	{ 0xd6, {0x028a, 0x0000, 0x0000} }, //latin small upsilon 
	{ 0xd7, {0x00e3, 0x0000, 0x0000} }, //a with ~
	{ 0xd8, {0x0251, 0x0000, 0x0000} }, //alpha 3b1
	{ 0xd9, {0x0061, 0x006f, 0x0000} }, //ao ?
	{ 0xda, {0x0254, 0x00f8, 0x0000} }, //open o, o with stroke
	{ 0xdb, {0x0259, 0x0000, 0x0000} }, //mid-central unrounded vowel
	{ 0xdc, {0x0153, 0x0000, 0x0000} }, //ligature oe
	{ 0xdd, {0xFFFD, 0} },
	{ 0xde, {0x012c, 0x0000, 0x0000} }, //I With Breve
	{ 0xdf, {0xFFFD, 0} }, 
	{ 0xe1, {0x0272, 0x0000, 0x0000} }, //N with Left Hook
	{ 0xe2, {0xFFFD, 0} },
	{ 0xe3, {0x00f8, 0x0000, 0x0000} }, //o with stroke ?
	{ 0xe4, {0xFFFD, 0} }, 
	{ 0xe5, {0xFFFD, 0} },
	{ 0xe6, {0xFFFD, 0} },
	{ 0xe7, {0xFFFD, 0} },
	{ 0xe8, {0xFFFD, 0} },
	{ 0xe9, {0xFFFD, 0} },
	{ 0xea, {0xFFFD, 0} },
	{ 0xeb, {0xFFFD, 0} },
	{ 0xec, {0xFFFD, 0} },
	{ 0xed, {0xFFFD, 0} },
	{ 0xee, {0xFFFD, 0} },
	{ 0xef, {0xFFFD, 0} },
	{ 0xf1, {0xFFFD, 0} },
	{ 0xf2, {0xFFFD, 0} },
	{ 0xf3, {0xFFFD, 0} },
	{ 0xf4, {0x00cf, 0x0000, 0x0000} }, //I With Diaeresis
	{ 0xf5, {0x00ef, 0x0000, 0x0000} }, //i With Diaeresis
	{ 0xf6, {0xFFFD, 0} },
	{ 0xf7, {0xFFFD, 0} },
	{ 0xf8, {0xFFFD, 0} },
	{ 0xf9, {0xFFFD, 0} },
	{ 0xfa, {0xFFFD, 0} },
	{ 0xfb, {0xFFFD, 0} },
	{ 0xfc, {0xFFFD, 0} },
	{ 0xfd, {0xFFFD, 0} },
	{ 0xfe, {0xFFFD, 0} },
	{ 0xff, {0xFFFD, 0} }
};

using namespace std;


ostream& operator<< (ostream &os, wchar_t *ws) {
	char buf[1024];
	if (! WideCharToMultiByte(CP_UTF8, 0,ws, -1, buf, 4096, NULL, NULL) ) {
		msg("error");
	}
	os << buf; 
	return os;
}


HWND HWMW;
HWND HWFV;
HWND HWRE;
HWND HWWL;

HDC ODC; 
bool painActive; 
ofstream *outf;
HANDLE muth; 
HANDLE pae, bpe, epe;
HANDLE ms;


class TSound{
	static TSound *cur;
	static HANDLE sndEvent;
	static int curnum(void) { return cur->num;};
	int x, y; 
	int num;
	HWND hw; 
public :
	TSound(HWND ahw, int ax, int ay) ;
	static void process(void);
	static int sndnum;
	friend BOOL __stdcall ssndPlaySound (LPCWSTR lpszSound, UINT fuSound);
	static int cn() { return sndnum; };
};
int TSound::sndnum = 0;
static deque<TSound*> sndQueue;
TSound  *TSound::cur = NULL;
HANDLE TSound::sndEvent = CreateEvent(NULL, true, false, NULL);

TSound::TSound(HWND ahw,int ax, int ay) { 
	hw = ahw; 
	x = ax; 
	y = ay; 
	num = sndnum++; 
	sndQueue.push_back(this);
}

void TSound::process(void) {
	deque<TSound*>::iterator si;
	for (si = sndQueue.begin(); si != sndQueue.end(); si++) {
		ResetEvent(sndEvent);
		cur = *si;
		PostMessage(cur->hw, WM_LBUTTONDOWN, MK_LBUTTON, MAKELPARAM(cur->x, cur->y));
		PostMessage(cur->hw, WM_LBUTTONUP, 0, MAKELPARAM(cur->x, cur->y));
		if ( WaitForSingleObject(sndEvent, 10000) == WAIT_TIMEOUT) {
			msg("Sound Error");
		}
	}
	sndQueue.clear();
	};
	

typedef HDC (__stdcall *TBeginPaint)(HWND, LPPAINTSTRUCT);
TIntrFunc<TBeginPaint> *fbp; 
HDC __stdcall sBeginPaint(HWND hwnd, LPPAINTSTRUCT lpPaint) {
	HDC r; 
	r = fbp->orig()(hwnd, lpPaint);

	char cn [1024];
	assert ( GetClassName(hwnd, cn, 1024) );
	if (hwnd == HWFV) {
		if ( WaitForSingleObject(pae, 500) == WAIT_OBJECT_0) {
			ResetEvent(pae);
			WaitForSingleObject(muth, INFINITE);
			assert(painActive == false);
			painActive = true; 
			ODC = r; 
			*outf << "Begin Paint" << endl ; 
			ReleaseMutex(muth);
			SetEvent(bpe);
		}
	}
	return r;
};




typedef BOOL (__stdcall *TTextOut)(HDC,int,int,LPCWSTR,int);
TIntrFunc<TTextOut> *fto;
BOOL WINAPI sTextOut (HDC hd,int x,int y,LPCWSTR s,int i) {
	if (painActive && (hd == ODC) ) {
		WaitForSingleObject(muth, INFINITE);
		char buf[4096];
		*outf << "TextOut ";
		GetTextFace(hd, 4096, buf);
		*outf <<  buf << " ";		
		TEXTMETRIC tm;
		GetTextMetrics(ODC, &tm);
		*outf << tm.tmHeight << " " << tm.tmWeight << " ";
		if (tm.tmItalic) *outf << "I "; 
		if (tm.tmUnderlined) *outf << "U ";
		*outf << hex << GetTextColor(ODC) << dec << " ";
		*outf << x << " " << y << " |"<< (wchar_t*)s << endl;
		ReleaseMutex(muth);
	};
	return fto->orig()(hd,x,y,s,i);
}


typedef BOOL (__stdcall *TTextOutA)(HDC,int,int,LPCTSTR,int);
TIntrFunc<TTextOutA> *ftoa;
BOOL WINAPI sTextOutA (HDC hd,int x,int y,LPCTSTR s,int i) {
	if (painActive && (hd == ODC) ) {
		WaitForSingleObject(muth, INFINITE);
		wchar_t wbuf[1024];
		wchar_t *wc = wbuf;
		wbuf[0] = (wchar_t)0;

		for (char *sc = (char*)s; *sc != 0; sc++) {
			unsigned char uc = *(unsigned char*)sc;
			for (int i = 0; i < nloem1; i++) {
				if ( (loem1[i].start <= uc) && (uc <= loem1[i].end) ) {
					*wc++ = (wchar_t)(loem1[i].unicode + uc - loem1[i].start);
					goto l;
				}
			}
			for (int i = 0; i < nloem2; i++) {
				if (uc == loem2[i].ch) {
					wchar_t *wtc = loem2[i].wcs;
					while (*wtc != 0) *wc++ = *wtc++;
					goto l;
				}
			}
			l:{};
		}
		*wc = 0;
		*outf << "TextOutA " << x << ", " << y << ", " << i << " | " << wbuf << endl;
		ReleaseMutex(muth);
	};
	return ftoa->orig()(hd,x,y,s,i);
}



typedef BOOL (__stdcall *TBitBlt)
	(HDC hdcDest, int nXDest, int nYDest, int nWidth, int nHeight,
	HDC hdcSrc, int nXSrc, int nYSrc, DWORD dwRop);
TIntrFunc<TBitBlt> *fbb;

BOOL __stdcall sBitBlt (HDC hdcDest, int nXDest, int nYDest, int nWidth, int nHeight,
						HDC hdcSrc, int nXSrc, int nYSrc, DWORD dwRop) {
	if (painActive && (hdcDest == ODC)) {
		WaitForSingleObject(muth, INFINITE);
		*outf << "snd " << TSound::cn() << endl;
		new TSound(HWFV, nXDest, nYDest - GetScrollPos(HWFV, SB_VERT) );
		ReleaseMutex(muth);
	}
	return fbb->orig() (hdcDest, nXDest, nYDest, nWidth, nHeight, hdcSrc, nXSrc, nYSrc, dwRop);
}


typedef BOOL (__stdcall *TsndPlaySound) (LPCWSTR lpszSound, UINT fuSound);
TIntrFunc<TsndPlaySound> *fps;
BOOL __stdcall ssndPlaySound (LPCWSTR lpszSound, UINT fuSound) {
	if ( (fuSound && SND_MEMORY) != 0) {
		WaitForSingleObject(muth,INFINITE);
		char str[1024];
		sprintf(str, "snd%d.wav", TSound::curnum());
		ofstream(str, ios_base::binary ).write((const char*)lpszSound, ((DWORD*)lpszSound)[1]+8);
		ReleaseMutex(muth);
		//fps->orig() (lpszSound, fuSound);
		//fps->enable();
		SetEvent(TSound::sndEvent);
	}
	return true;
};


typedef BOOL (__stdcall *TEndPaint) (HWND, const PAINTSTRUCT*);
TIntrFunc<TEndPaint> *fep;
BOOL __stdcall sEndPaint(HWND hWnd,const PAINTSTRUCT *lpPaint) {
	if (painActive && (lpPaint->hdc ==ODC) ) { 
		char cn [1024];
		painActive = false; 
		WaitForSingleObject(muth, INFINITE);
		*outf << "EndPaint" << endl << endl;
		ReleaseMutex(muth);
		SetEvent(epe);
	}
	return fep->orig()(hWnd, lpPaint);
};



void processView() {
	SetEvent(pae);
	if ( WaitForSingleObject(bpe, 500) == WAIT_TIMEOUT ) {
		//msg("bpe");
		InvalidateRect(HWFV, NULL, true);
		UpdateWindow(HWFV);
		WaitForSingleObject(bpe, INFINITE);
	}
	ResetEvent(bpe);
	WaitForSingleObject(epe, INFINITE);
	ResetEvent(epe);
	TSound::process();
};


bool isScroll (HWND hw) {
	SCROLLBARINFO sbi;
	ZeroMemory(&sbi, sizeof(sbi));
	sbi.cbSize = sizeof(sbi);
	assert ( GetScrollBarInfo(hw, OBJID_VSCROLL, &sbi) );
	return  (sbi.rgstate[0] & (STATE_SYSTEM_OFFSCREEN | STATE_SYSTEM_INVISIBLE | STATE_SYSTEM_UNAVAILABLE) ) == 0;
}

bool isSBE (HWND hw) {
	if (! isScroll(hw) ) return true;
	SCROLLINFO si;
	ZeroMemory(&si, sizeof(si));
	si.cbSize = sizeof(SCROLLINFO);
	si.fMask = SIF_POS | SIF_RANGE | SIF_PAGE;
	assert ( GetScrollInfo(hw, SB_VERT, &si) );
	return si.nPos + si.nPage >= si.nMax;
}

void init (void) {
	HANDLE mse = CreateEvent(NULL, true, false, mseName);
	WaitForSingleObject(mse, INFINITE);
	char rb[bufsize];
	DWORD nbr;
	ReadFile(ms, rb, bufsize, &nbr, NULL);
	SetCurrentDirectory(rb);
	assert(nbr == bufsize);
	CloseHandle(mse);
	CloseHandle(ms);
	
	HWMW = FindWindow("LV9_MainWindow",NULL);
	HWND HWVC = FindWindowEx (HWMW, 0, "LingvoViewClass", NULL);
	HWWL = FindWindowEx(HWVC, 0, "LingvoListWndClass", NULL);
	HWRE = FindWindowEx (HWVC, 0, "RichEdit20W", NULL);
	HWND HWTC = FindWindow("LvTransCardFrame",0);
	if (HWTC == 0) {
		PostMessage(HWMW, WM_COMMAND, 0x00007554, 0);
		while ( !(HWTC = FindWindow("LvTransCardFrame",0)) );
	}
	do { HWFV = FindWindowEx(HWTC, 0, "AfxFrameOrView42u", NULL); } while (HWFV == 0);
		
	painActive = false;
	muth = CreateMutex(NULL, false, NULL);
	epe = CreateEvent(NULL, true, false, NULL);
	bpe = CreateEvent(NULL, true, false, NULL);
	pae = CreateEvent(NULL, true, false, NULL);
	
	fbp  = new TIntrFunc <TBeginPaint>     ( (TBeginPaint*)    0x3909e55c, &sBeginPaint );
	fto  = new TIntrFunc <TTextOut>        ( (TTextOut*)       0x00633F68, &sTextOut);
	ftoa = new TIntrFunc <TTextOutA>       ( (TTextOutA*)      0x005c9d6c, &sTextOutA);
	fbb  = new TIntrFunc <TBitBlt>         ( (TBitBlt*)        0x005c9d64, &sBitBlt);
	fps  = new TIntrFunc <TsndPlaySound>   ( (TsndPlaySound*)  0x006340a8, &ssndPlaySound);
	fep  = new TIntrFunc <TEndPaint>       ( (TEndPaint*)      0x3909e558, &sEndPaint );

	fbp->enable(); 
	fto->enable();
	ftoa->enable();
	fbb->enable();
	fps->enable();
	fep->enable();

	ifstream cfgf (cfg); cfgf >> TSound::sndnum;
	outf = new ofstream(fnTxtOut,ios_base::app);
};


DWORD WINAPI GrabThread(LPVOID lpParameter) {
	init();
	while (! isSBE(HWWL) ) {
	//for (int i = 0; i < 10; i++) 
	//{
		WaitForSingleObject(muth, INFINITE);
		*outf << "Word " << endl << endl;
		ReleaseMutex(muth);

		PostMessage(HWMW, WM_COMMAND, 0x00007554, 0);
		processView();
		if ( isScroll(HWFV) ) {
			while (!isSBE(HWFV) ) {
				PostMessage(HWFV, WM_KEYDOWN, 0x00000022, 0x01510001);
				processView();
			}
		}
		PostMessage (HWRE, WM_KEYDOWN, 0x00000028, 0x01500001);
	}
	delete outf;
	msg("Complete");
	ExitProcess(0);
	return 0;
}



BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved		
					   )
{ 
	if  (ul_reason_for_call == DLL_PROCESS_ATTACH) {
		ms = CreateMailslot(mailslotname, bufsize, MAILSLOT_WAIT_FOREVER, NULL);
		CreateThread(NULL, 0, &GrabThread, NULL, 0, NULL);
		return true;
	}
	if (ul_reason_for_call == DLL_PROCESS_DETACH) {
		delete outf; 
	}
    return TRUE;
}

